//////////////////////////////////////////
//
// NOTE: This is *not* a valid shader file
//
///////////////////////////////////////////
Shader "Spine/Skeleton" {
    Properties {
        _Cutoff ("Shadow alpha cutoff", Range(0, 1)) = 0.1
        _MainTex ("Main Texture", 2D) = "black" { }
        [Toggle(_STRAIGHT_ALPHA_INPUT)] _StraightAlphaInput ("Straight Alpha Texture", Float) = 0
        _StencilRef ("Stencil Reference", Float) = 1
        [Enum(UnityEngine.Rendering.CompareFunction)] _StencilComp ("Stencil Comparison", Float) = 8
        _OutlineWidth ("Outline Width", Range(0, 8)) = 3
        [MaterialToggle(_USE_SCREENSPACE_OUTLINE_WIDTH)] _UseScreenSpaceOutlineWidth ("Width in Screen Space", Float) = 0
        _OutlineColor ("Outline Color", Color) = (1,1,0,1)
        _OutlineReferenceTexWidth ("Reference Texture Width", Float) = 1024
        _ThresholdEnd ("Outline Threshold", Range(0, 1)) = 0.25
        _OutlineSmoothness ("Outline Smoothness", Range(0, 1)) = 1
        [MaterialToggle(_USE8NEIGHBOURHOOD_ON)] _Use8Neighbourhood ("Sample 8 Neighbours", Float) = 1
        _OutlineOpaqueAlpha ("Opaque Alpha", Range(0, 1)) = 1
        _OutlineMipLevel ("Outline Mip Level", Range(0, 3)) = 0
    }
    SubShader {
        Tags { "IGNOREPROJECTOR" = "true" "PreviewType" = "Plane" "QUEUE" = "Transparent" "RenderType" = "Transparent" }
        Pass {
            Name "Normal"
            Tags { "IGNOREPROJECTOR" = "true" "PreviewType" = "Plane" "QUEUE" = "Transparent" "RenderType" = "Transparent" }
            Blend One OneMinusSrcAlpha, One OneMinusSrcAlpha
            ZWrite Off
            Cull Off
            Stencil {
                Comp Disabled
                Pass Keep
                Fail Keep
                ZFail Keep
            }
            Fog {
                Mode Off
            }
            GpuProgramID 8576
            PlayerProgram "vp" {
                SubProgram "gles3 " {
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 hlslcc_mtx4x4unity_ObjectToWorld[4];
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    in highp vec4 in_POSITION0;
                    in highp vec2 in_TEXCOORD0;
                    in highp vec4 in_COLOR0;
                    out highp vec2 vs_TEXCOORD0;
                    out highp vec4 vs_COLOR0;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    void main()
                    {
                        u_xlat0 = in_POSITION0.yyyy * hlslcc_mtx4x4unity_ObjectToWorld[1];
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[0] * in_POSITION0.xxxx + u_xlat0;
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[2] * in_POSITION0.zzzz + u_xlat0;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_ObjectToWorld[3];
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        gl_Position = hlslcc_mtx4x4unity_MatrixVP[3] * u_xlat0.wwww + u_xlat1;
                        vs_TEXCOORD0.xy = in_TEXCOORD0.xy;
                        vs_COLOR0 = in_COLOR0;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in highp vec2 vs_TEXCOORD0;
                    in highp vec4 vs_COLOR0;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout highp vec4 SV_Target0;
                    #else
                    layout(location = 0) out highp vec4 SV_Target0;
                    #endif
                    vec4 u_xlat0;
                    void main()
                    {
                        u_xlat0 = texture(_MainTex, vs_TEXCOORD0.xy);
                        SV_Target0 = u_xlat0 * vs_COLOR0;
                        return;
                    }
                    
                    #endif
                    "
                }
            }
        }
        Pass {
            Name "Caster"
            Tags { "IGNOREPROJECTOR" = "true" "LIGHTMODE" = "SHADOWCASTER" "PreviewType" = "Plane" "QUEUE" = "Transparent" "RenderType" = "Transparent" "SHADOWSUPPORT" = "true" }
            Blend One OneMinusSrcAlpha, One OneMinusSrcAlpha
            Cull Off
            Offset 1, 1
            Stencil {
                Comp Disabled
                Pass Keep
                Fail Keep
                ZFail Keep
            }
            Fog {
                Mode Off
            }
            GpuProgramID 126311
            PlayerProgram "vp" {
                SubProgram "gles3 " {
                    Keywords { "SHADOWS_DEPTH" }
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 unity_LightShadowBias;
                    uniform 	vec4 hlslcc_mtx4x4unity_ObjectToWorld[4];
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    in highp vec4 in_POSITION0;
                    in highp vec4 in_TEXCOORD0;
                    in highp vec4 in_COLOR0;
                    out highp vec4 vs_TEXCOORD1;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    float u_xlat4;
                    void main()
                    {
                        u_xlat0 = in_POSITION0.yyyy * hlslcc_mtx4x4unity_ObjectToWorld[1];
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[0] * in_POSITION0.xxxx + u_xlat0;
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[2] * in_POSITION0.zzzz + u_xlat0;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_ObjectToWorld[3];
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[3] * u_xlat0.wwww + u_xlat1;
                        u_xlat1.x = unity_LightShadowBias.x / u_xlat0.w;
                        u_xlat1.x = clamp(u_xlat1.x, 0.0, 1.0);
                        u_xlat4 = u_xlat0.z + u_xlat1.x;
                        u_xlat1.x = max((-u_xlat0.w), u_xlat4);
                        gl_Position.xyw = u_xlat0.xyw;
                        u_xlat0.x = (-u_xlat4) + u_xlat1.x;
                        gl_Position.z = unity_LightShadowBias.y * u_xlat0.x + u_xlat4;
                        vs_TEXCOORD1.xyz = in_TEXCOORD0.xyz;
                        vs_TEXCOORD1.w = in_COLOR0.w;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	mediump float _Cutoff;
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in highp vec4 vs_TEXCOORD1;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout highp vec4 SV_Target0;
                    #else
                    layout(location = 0) out highp vec4 SV_Target0;
                    #endif
                    float u_xlat0;
                    bool u_xlatb0;
                    void main()
                    {
                        u_xlat0 = texture(_MainTex, vs_TEXCOORD1.xy).w;
                        u_xlat0 = u_xlat0 * vs_TEXCOORD1.w + (-_Cutoff);
                        u_xlatb0 = u_xlat0<0.0;
                        if(u_xlatb0){discard;}
                        SV_Target0 = vec4(0.0, 0.0, 0.0, 0.0);
                        return;
                    }
                    
                    #endif
                    "
                }
                SubProgram "gles3 " {
                    Keywords { "SHADOWS_CUBE" }
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 unity_LightShadowBias;
                    uniform 	vec4 hlslcc_mtx4x4unity_ObjectToWorld[4];
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    in highp vec4 in_POSITION0;
                    in highp vec4 in_TEXCOORD0;
                    in highp vec4 in_COLOR0;
                    out highp vec4 vs_TEXCOORD1;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    void main()
                    {
                        u_xlat0 = in_POSITION0.yyyy * hlslcc_mtx4x4unity_ObjectToWorld[1];
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[0] * in_POSITION0.xxxx + u_xlat0;
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[2] * in_POSITION0.zzzz + u_xlat0;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_ObjectToWorld[3];
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[3] * u_xlat0.wwww + u_xlat1;
                        u_xlat1.x = max((-u_xlat0.w), u_xlat0.z);
                        u_xlat1.x = (-u_xlat0.z) + u_xlat1.x;
                        gl_Position.z = unity_LightShadowBias.y * u_xlat1.x + u_xlat0.z;
                        gl_Position.xyw = u_xlat0.xyw;
                        vs_TEXCOORD1.xyz = in_TEXCOORD0.xyz;
                        vs_TEXCOORD1.w = in_COLOR0.w;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	mediump float _Cutoff;
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in highp vec4 vs_TEXCOORD1;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout highp vec4 SV_Target0;
                    #else
                    layout(location = 0) out highp vec4 SV_Target0;
                    #endif
                    float u_xlat0;
                    bool u_xlatb0;
                    void main()
                    {
                        u_xlat0 = texture(_MainTex, vs_TEXCOORD1.xy).w;
                        u_xlat0 = u_xlat0 * vs_TEXCOORD1.w + (-_Cutoff);
                        u_xlatb0 = u_xlat0<0.0;
                        if(u_xlatb0){discard;}
                        SV_Target0 = vec4(0.0, 0.0, 0.0, 0.0);
                        return;
                    }
                    
                    #endif
                    "
                }
            }
        }
    }
CustomEditor "SpineShaderWithOutlineGUI"
}